package com.example.services;

import java.util.concurrent.TimeUnit;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.services.events.IEventBroker;

import com.example.model.Bread;
import com.example.model.IBread;

public class BreadClientService {

	@Execute
	public void init(final IEventBroker broker) {
		Job job = new Job("bread.delivery") {
			@Override
			protected IStatus run(IProgressMonitor monitor) {
				try {
					TimeUnit.SECONDS.sleep(3);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}

				System.out.println("bread could be delivered internally");
				
				broker.post(IBread.ME, new Bread());
				return Status.OK_STATUS;
			}
		};
		job.schedule();
		
		System.out.println("Bread Client loaded");
	}
}